///////////////////////////////////////////////////////////////////////////////
// Name:		wxScrollText.cpp
// Purpose:     Scrolling Text
// Author:      emarti, Murat zdemir  e-mail: dtemarti<add>gmail<dot>com
// Created:     26.04.2006
// Copyright:   (c) emarti
// Licence:     GPL
///////////////////////////////////////////////////////////////////////////////

#ifndef WX_PRECOMP 
    #include "wx/wx.h" 
#endif 

#include "wxScrollText.h"

BEGIN_EVENT_TABLE(wxScrollText, wxControl)
	EVT_TIMER(wxID_ANY,wxScrollText::Timer)
END_EVENT_TABLE()

wxScrollText::wxScrollText(wxWindow *parent, wxWindowID id, wxString value, int x, int y, int width, int height) 
                  : wxControl(parent, id,  wxPoint(x, y), wxSize(width, height), wxBORDER_NONE) 
{ 	
	w = width;
	h = height;
	sp = 1;
	s = w;
	
	WxTimer = new wxTimer();
	WxTimer->SetOwner(this, wxID_ANY);
	m_timer = TIMER;

	SetBackgroundColour(wxColour(*wxWHITE));
	WxStaticText = new wxStaticText(this, wxID_ANY, value, wxPoint(w,0), wxDefaultSize, wxTRANSPARENT_WINDOW);
	WxStaticText->SetBackgroundColour(wxColour(*wxWHITE));
	WxStaticText->SetForegroundColour(wxColour(*wxBLACK));
	WxStaticText->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, FALSE, wxT("Verdana")));

	tsize = WxStaticText->GetBestSize();
	
	wxControl::Enable(true);
	Show(true);	
} 

wxScrollText::~wxScrollText() 
{ 
	delete WxTimer;
	delete WxStaticText;
} 

void wxScrollText::Timer(wxTimerEvent& event)
{
	s-= sp;
	WxStaticText->SetSize(s,0,tsize.x, h /*tsize.y*/);
	if ((s+tsize.x)<0) s= w;
	event.Skip();
}

void wxScrollText::SetFont(wxFont font)
{
	WxStaticText->SetFont(font);
	tsize = WxStaticText->GetBestSize();
	
}

void wxScrollText::SetForeground_Colour(wxColour colour)
{
	WxStaticText->SetForegroundColour(colour);
}

void wxScrollText::SetBackground_Colour(wxColour colour)
{
	WxStaticText->SetBackgroundColour(colour);
	SetBackgroundColour(colour);
}

void wxScrollText::SetScrollPixel(int scrollpixel)
{
	sp = scrollpixel;
}

void wxScrollText::SetTimer(int timer)
{
	m_timer = timer;
}

void wxScrollText::SetText(wxString text)
{
	WxStaticText->SetLabel(text);
	tsize = WxStaticText->GetBestSize();
}

void wxScrollText::Start()
{
	WxTimer->Start(m_timer);
}

void wxScrollText::Stop()
{
	WxTimer->Stop();
}
