///////////////////////////////////////////////////////////////////////////////
// Name:		wxScrollText.h
// Purpose:     Scrolling Text
// Author:      emarti, Murat zdemir  e-mail: dtemarti<add>gmail<dot>com
// Created:     26.04.2006
// Copyright:   (c) emarti
// Licence:     GPL
///////////////////////////////////////////////////////////////////////////////

/*
	usage:
		ScrollText = new wxScrollText(this, wxID_ANY, _T("Scrolling Text"), 10, 10, 100, 25);
		ScrollText->SetForeground_Colour(wxColour(128,128,128));
		ScrollText->SetFont(wxFont(7, wxMODERN, wxSLANT, wxBOLD , FALSE, wxT("Tahoma")));
		ScrollText->SetTimer(30);
		ScrollText->SetScrollPixel(2);
		ScrollText->SetText(_T("One man's constant is another man's variable. Alan Perlis"));
		ScrollText->Start();

	todo: 
		Prevent blink while scrolling text.
*/

#ifndef wxScrollText_H
#define wxScrollText_H

#define TIMER		50

#include <wx/timer.h>
#include <wx/stattext.h>

class wxScrollText : public wxControl{ 
	public: 
        wxScrollText(wxWindow *parent, wxWindowID id, wxString value, int x, int y, int width, int height);
		virtual ~wxScrollText(); 
		void SetFont(wxFont font);
		void SetForeground_Colour(wxColour colour);
		void SetBackground_Colour(wxColour colour);
		void SetScrollPixel(int scrollpixel);
		void SetTimer(int timer);
		void SetText(wxString text);
		void Start();
		void Stop();

	private: 
        int w,h,s,sp,m_timer;
		wxSize tsize;
		wxTimer* WxTimer;
		wxStaticText *WxStaticText;
		void Timer(wxTimerEvent& event);
		DECLARE_EVENT_TABLE() 
}; 

#endif
